stages:
  - build
  - deploy

variables:
  DEPLOYMENT_ZIP: server-manager-lambda.zip
  LAMBDA_NAME: us-east-2-server-manager

build:
  image: node:fermium
  stage: build
  script:
    - apt-get update
    - apt-get -y install zip unzip
    - npm --unsafe-perm install
    - npm run build
    - mkdir artifacts
    - cp package.json dist && cd dist && npm install --production
    - zip -r $DEPLOYMENT_ZIP *; cp $DEPLOYMENT_ZIP ../artifacts; cd ..
  artifacts:
    paths:
      - artifacts/

deploy:
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest  # see the note below
  stage: deploy
  script:
    - aws s3 cp artifacts/$DEPLOYMENT_ZIP s3://us-east-2-webquake-deployments/$DEPLOYMENT_ZIP
    - aws lambda update-function-code --function-name $LAMBDA_NAME --s3-bucket us-east-2-webquake-deployments --s3-key $DEPLOYMENT_ZIP --region us-east-2
